Index: c/src/lib/libcpu/powerpc/mpc55xx/include/emios.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/include/emios.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
+++ c/src/lib/libcpu/powerpc/mpc55xx/include/emios.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -0,0 +1,192 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief Enhanced Modular Input Output Subsystem (eMIOS).
+ */
+
+/*
+ * Copyright (c) 2009
+ * embedded brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+#ifndef LIBCPU_POWERPC_MPC55XX_EMIOS_H
+#define LIBCPU_POWERPC_MPC55XX_EMIOS_H
+
+#include <stdbool.h>
+#include <stdint.h>
+
+#include <rtems.h>
+#include <rtems/chain.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif /* __cplusplus */
+
+/**
+ * @name eMIOS - Modes
+ *
+ * @{
+ */
+
+#define MPC55XX_EMIOS_MODE_GPIO_INPUT 0U
+#define MPC55XX_EMIOS_MODE_GPIO_OUTPUT 1U
+#define MPC55XX_EMIOS_MODE_SAIC 2U
+#define MPC55XX_EMIOS_MODE_SAOC 3U
+#define MPC55XX_EMIOS_MODE_IPWM 4U
+#define MPC55XX_EMIOS_MODE_IPM 5U
+#define MPC55XX_EMIOS_MODE_DAOC_SECOND 6U
+#define MPC55XX_EMIOS_MODE_DAOC_BOTH 7U
+#define MPC55XX_EMIOS_MODE_PEA_ACCU_CONT 8U
+#define MPC55XX_EMIOS_MODE_PEA_ACCU_SINGLE 9U
+#define MPC55XX_EMIOS_MODE_PEA_COUNT_CONT 10U
+#define MPC55XX_EMIOS_MODE_PEA_COUNT_SINGLE 11U
+#define MPC55XX_EMIOS_MODE_QDEC_COUNT_DIR 12U
+#define MPC55XX_EMIOS_MODE_QDEC_PHASE 13U
+#define MPC55XX_EMIOS_MODE_WPTA 14U
+#define MPC55XX_EMIOS_MODE_RESERVED_15 15U
+#define MPC55XX_EMIOS_MODE_MC_UP_INT_CLK 16U
+#define MPC55XX_EMIOS_MODE_MC_UP_EXT_CLK 17U
+#define MPC55XX_EMIOS_MODE_RESERVED_18 18U
+#define MPC55XX_EMIOS_MODE_RESERVED_19 19U
+#define MPC55XX_EMIOS_MODE_MC_UP_DOWN_INT_CLK 20U
+#define MPC55XX_EMIOS_MODE_MC_UP_DOWN_EXT_CLK 21U
+#define MPC55XX_EMIOS_MODE_MC_UP_DOWN_CHANGE_INT_CLK 22U
+#define MPC55XX_EMIOS_MODE_MC_UP_DOWN_CHANGE_EXT_CLK 23U
+#define MPC55XX_EMIOS_MODE_OPWFM_B_IMMEDIATE 24U
+#define MPC55XX_EMIOS_MODE_OPWFM_B_NEXT_PERIOD 25U
+#define MPC55XX_EMIOS_MODE_OPWFM_AB_IMMEDIATE 26U
+#define MPC55XX_EMIOS_MODE_OPWFM_AB_NEXT_PERIOD 27U
+#define MPC55XX_EMIOS_MODE_OPWMC_TRAIL_TRAIL 28U
+#define MPC55XX_EMIOS_MODE_OPWMC_TRAIL_LEAD 29U
+#define MPC55XX_EMIOS_MODE_OPWMC_BOTH_TRAIL 30U
+#define MPC55XX_EMIOS_MODE_OPWMC_BOTH_LEAD 31U
+#define MPC55XX_EMIOS_MODE_OPWM_B_IMMEDIATE 32U
+#define MPC55XX_EMIOS_MODE_OPWM_B_NEXT_PERIOD 33U
+#define MPC55XX_EMIOS_MODE_OPWM_AB_IMMEDIATE 34U
+#define MPC55XX_EMIOS_MODE_OPWM_AB_NEXT_PERIOD 35U
+#define MPC55XX_EMIOS_MODE_RESERVED_36 36U
+#define MPC55XX_EMIOS_MODE_RESERVED_37 37U
+#define MPC55XX_EMIOS_MODE_RESERVED_38 38U
+#define MPC55XX_EMIOS_MODE_RESERVED_39 39U
+#define MPC55XX_EMIOS_MODE_RESERVED_40 40U
+#define MPC55XX_EMIOS_MODE_RESERVED_41 41U
+#define MPC55XX_EMIOS_MODE_RESERVED_42 42U
+#define MPC55XX_EMIOS_MODE_RESERVED_43 43U
+#define MPC55XX_EMIOS_MODE_RESERVED_44 44U
+#define MPC55XX_EMIOS_MODE_RESERVED_45 45U
+#define MPC55XX_EMIOS_MODE_RESERVED_46 46U
+#define MPC55XX_EMIOS_MODE_RESERVED_47 47U
+#define MPC55XX_EMIOS_MODE_RESERVED_48 48U
+#define MPC55XX_EMIOS_MODE_RESERVED_49 49U
+#define MPC55XX_EMIOS_MODE_RESERVED_50 50U
+#define MPC55XX_EMIOS_MODE_RESERVED_51 51U
+#define MPC55XX_EMIOS_MODE_RESERVED_52 52U
+#define MPC55XX_EMIOS_MODE_RESERVED_53 53U
+#define MPC55XX_EMIOS_MODE_RESERVED_54 54U
+#define MPC55XX_EMIOS_MODE_RESERVED_55 55U
+#define MPC55XX_EMIOS_MODE_RESERVED_56 56U
+#define MPC55XX_EMIOS_MODE_RESERVED_57 57U
+#define MPC55XX_EMIOS_MODE_RESERVED_58 58U
+#define MPC55XX_EMIOS_MODE_RESERVED_59 59U
+#define MPC55XX_EMIOS_MODE_RESERVED_60 60U
+#define MPC55XX_EMIOS_MODE_RESERVED_61 61U
+#define MPC55XX_EMIOS_MODE_RESERVED_62 62U
+#define MPC55XX_EMIOS_MODE_RESERVED_63 63U
+#define MPC55XX_EMIOS_MODE_RESERVED_64 64U
+#define MPC55XX_EMIOS_MODE_RESERVED_65 65U
+#define MPC55XX_EMIOS_MODE_RESERVED_66 66U
+#define MPC55XX_EMIOS_MODE_RESERVED_67 67U
+#define MPC55XX_EMIOS_MODE_RESERVED_68 68U
+#define MPC55XX_EMIOS_MODE_RESERVED_69 69U
+#define MPC55XX_EMIOS_MODE_RESERVED_70 70U
+#define MPC55XX_EMIOS_MODE_RESERVED_71 71U
+#define MPC55XX_EMIOS_MODE_RESERVED_72 72U
+#define MPC55XX_EMIOS_MODE_RESERVED_73 73U
+#define MPC55XX_EMIOS_MODE_RESERVED_74 74U
+#define MPC55XX_EMIOS_MODE_RESERVED_75 75U
+#define MPC55XX_EMIOS_MODE_RESERVED_76 76U
+#define MPC55XX_EMIOS_MODE_RESERVED_77 77U
+#define MPC55XX_EMIOS_MODE_RESERVED_78 78U
+#define MPC55XX_EMIOS_MODE_RESERVED_79 79U
+#define MPC55XX_EMIOS_MODE_MCB_UP_INT_CLK 80U
+#define MPC55XX_EMIOS_MODE_MCB_UP_EXT_CLK 81U
+#define MPC55XX_EMIOS_MODE_RESERVED_82 82U
+#define MPC55XX_EMIOS_MODE_RESERVED_83 83U
+#define MPC55XX_EMIOS_MODE_MCB_UP_DOWN_ONE_INT_CLK 84U
+#define MPC55XX_EMIOS_MODE_MCB_UP_DOWN_ONE_EXT_CLK 85U
+#define MPC55XX_EMIOS_MODE_MCB_UP_DOWN_BOTH_INT_CLK 86U
+#define MPC55XX_EMIOS_MODE_MCB_UP_DOWN_BOTH_EXT_CLK 87U
+#define MPC55XX_EMIOS_MODE_OPWFMB_B 88U
+#define MPC55XX_EMIOS_MODE_RESERVED_89 89U
+#define MPC55XX_EMIOS_MODE_OPWFMB_AB 90U
+#define MPC55XX_EMIOS_MODE_RESERVED_91 91U
+#define MPC55XX_EMIOS_MODE_OPWMCB_TRAIL_TRAIL 92U
+#define MPC55XX_EMIOS_MODE_OPWMCB_TRAIL_LEAD 93U
+#define MPC55XX_EMIOS_MODE_OPWMCB_BOTH_TRAIL 94U
+#define MPC55XX_EMIOS_MODE_OPWMCB_BOTH_LEAD 95U
+#define MPC55XX_EMIOS_MODE_OPWMB_SECOND 96U
+#define MPC55XX_EMIOS_MODE_RESERVED_97 97U
+#define MPC55XX_EMIOS_MODE_OPWMB_BOTH 98U
+#define MPC55XX_EMIOS_MODE_RESERVED_99 99U
+#define MPC55XX_EMIOS_MODE_RESERVED_100 100U
+#define MPC55XX_EMIOS_MODE_RESERVED_101 101U
+#define MPC55XX_EMIOS_MODE_RESERVED_102 102U
+#define MPC55XX_EMIOS_MODE_RESERVED_103 103U
+#define MPC55XX_EMIOS_MODE_RESERVED_104 104U
+#define MPC55XX_EMIOS_MODE_RESERVED_105 105U
+#define MPC55XX_EMIOS_MODE_RESERVED_106 106U
+#define MPC55XX_EMIOS_MODE_RESERVED_107 107U
+#define MPC55XX_EMIOS_MODE_RESERVED_108 108U
+#define MPC55XX_EMIOS_MODE_RESERVED_109 109U
+#define MPC55XX_EMIOS_MODE_RESERVED_110 110U
+#define MPC55XX_EMIOS_MODE_RESERVED_111 111U
+#define MPC55XX_EMIOS_MODE_RESERVED_112 112U
+#define MPC55XX_EMIOS_MODE_RESERVED_113 113U
+#define MPC55XX_EMIOS_MODE_RESERVED_114 114U
+#define MPC55XX_EMIOS_MODE_RESERVED_115 115U
+#define MPC55XX_EMIOS_MODE_RESERVED_116 116U
+#define MPC55XX_EMIOS_MODE_RESERVED_117 117U
+#define MPC55XX_EMIOS_MODE_RESERVED_118 118U
+#define MPC55XX_EMIOS_MODE_RESERVED_119 119U
+#define MPC55XX_EMIOS_MODE_RESERVED_120 120U
+#define MPC55XX_EMIOS_MODE_RESERVED_121 121U
+#define MPC55XX_EMIOS_MODE_RESERVED_122 122U
+#define MPC55XX_EMIOS_MODE_RESERVED_123 123U
+#define MPC55XX_EMIOS_MODE_RESERVED_124 124U
+#define MPC55XX_EMIOS_MODE_RESERVED_125 125U
+#define MPC55XX_EMIOS_MODE_RESERVED_126 126U
+#define MPC55XX_EMIOS_MODE_RESERVED_127 127U
+
+/** @} */
+
+#define MPC55XX_EMIOS_CHANNEL_NUMBER 24U
+
+#define MPC55XX_EMIOS_VALUE_MAX 0x00ffffffU
+
+#define MPC55XX_EMIOS_IS_CHANNEL_VALID( c) \
+  ((unsigned) (c) < MPC55XX_EMIOS_CHANNEL_NUMBER)
+
+#define MPC55XX_EMIOS_IS_CHANNEL_INVALID( c) \
+  (!MPC55XX_EMIOS_IS_CHANNEL_VALID( c))
+
+void mpc55xx_emios_initialize( unsigned prescaler);
+
+unsigned mpc55xx_emios_global_prescaler( void);
+
+void mpc55xx_emios_set_global_prescaler( unsigned prescaler);
+
+#ifdef __cplusplus
+}
+#endif /* __cplusplus */
+
+#endif /* LIBCPU_POWERPC_MPC55XX_EMIOS_H */
Index: c/src/lib/libcpu/powerpc/mpc55xx/include/irq.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/include/irq.h	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/include/irq.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -34,27 +34,44 @@
 
 /* Basics */
-#define MPC55XX_IRQ_MIN 0
-#define MPC55XX_IRQ_MAX 328
+#define MPC55XX_IRQ_MIN 0U
+#define MPC55XX_IRQ_MAX 328U
 #define MPC55XX_IRQ_BASE MPC55XX_IRQ_MIN
-#define MPC55XX_IRQ_NUMBER (MPC55XX_IRQ_MAX + 1)
+#define MPC55XX_IRQ_NUMBER (MPC55XX_IRQ_MAX + 1U)
 
 /* Software interrupts */
-#define MPC55XX_IRQ_SOFTWARE_MIN 0
-#define MPC55XX_IRQ_SOFTWARE_MAX 7
-#define MPC55XX_IRQ_SOFTWARE_NUMBER (MPC55XX_IRQ_SOFTWARE_MAX + 1)
+#define MPC55XX_IRQ_SOFTWARE_MIN 0U
+#define MPC55XX_IRQ_SOFTWARE_MAX 7U
+#define MPC55XX_IRQ_SOFTWARE_GET_INDEX( v) (v)
+#define MPC55XX_IRQ_SOFTWARE_GET_REQUEST( i) (i)
+#define MPC55XX_IRQ_SOFTWARE_NUMBER (MPC55XX_IRQ_SOFTWARE_MAX + 1U)
 
 /* eDMA interrupts */
-#define MPC55XX_IRQ_EDMA_ERROR_LOW 10
-#define MPC55XX_IRQ_EDMA_ERROR_HIGH 210
-#define MPC55XX_IRQ_EDMA_REQUEST_LOW_MIN 11
-#define MPC55XX_IRQ_EDMA_REQUEST_LOW_MAX 42
-#define MPC55XX_IRQ_EDMA_REQUEST_HIGH_MIN 211
-#define MPC55XX_IRQ_EDMA_REQUEST_HIGH_MAX 242
-#define MPC55XX_IRQ_EDMA_GET_CHANNEL( i) (((i) > MPC55XX_IRQ_EDMA_REQUEST_LOW_MAX) ? ((i) - MPC55XX_IRQ_EDMA_REQUEST_HIGH_MIN + 32) : ((i) - MPC55XX_IRQ_EDMA_REQUEST_LOW_MIN))
-#define MPC55XX_IRQ_EDMA_GET_REQUEST( c) (((c) > 31) ? ((c) + MPC55XX_IRQ_EDMA_REQUEST_HIGH_MIN - 32) : ((c) + MPC55XX_IRQ_EDMA_REQUEST_LOW_MIN))
+#define MPC55XX_IRQ_EDMA_ERROR_LOW 10U
+#define MPC55XX_IRQ_EDMA_ERROR_HIGH 210U
+#define MPC55XX_IRQ_EDMA_REQUEST_LOW_MIN 11U
+#define MPC55XX_IRQ_EDMA_REQUEST_LOW_MAX 42U
+#define MPC55XX_IRQ_EDMA_REQUEST_HIGH_MIN 211U
+#define MPC55XX_IRQ_EDMA_REQUEST_HIGH_MAX 242U
+#define MPC55XX_IRQ_EDMA_GET_CHANNEL( v) (((v) > MPC55XX_IRQ_EDMA_REQUEST_LOW_MAX) ? ((v) + 32U - MPC55XX_IRQ_EDMA_REQUEST_HIGH_MIN) : ((v) - MPC55XX_IRQ_EDMA_REQUEST_LOW_MIN))
+#define MPC55XX_IRQ_EDMA_GET_REQUEST( c) (((c) >= 32U) ? ((c) - 32U + MPC55XX_IRQ_EDMA_REQUEST_HIGH_MIN) : ((c) + MPC55XX_IRQ_EDMA_REQUEST_LOW_MIN))
+
+/* SIU external interrupts */
+#define MPC55XX_IRQ_SIU_EXTERNAL_0 46U
+#define MPC55XX_IRQ_SIU_EXTERNAL_1 47U
+#define MPC55XX_IRQ_SIU_EXTERNAL_2 48U
+#define MPC55XX_IRQ_SIU_EXTERNAL_3 49U
+#define MPC55XX_IRQ_SIU_EXTERNAL_4_15 50U
+
+/* eMIOS interrupts */
+#define MPC55XX_IRQ_EMIOS_REQUEST_LOW_MIN 51U
+#define MPC55XX_IRQ_EMIOS_REQUEST_LOW_MAX 66U
+#define MPC55XX_IRQ_EMIOS_REQUEST_HIGH_MIN 202U
+#define MPC55XX_IRQ_EMIOS_REQUEST_HIGH_MAX 209U
+#define MPC55XX_IRQ_EMIOS_GET_CHANNEL( v) (((v) > MPC55XX_IRQ_EMIOS_REQUEST_LOW_MAX) ? ((v) + 16U - MPC55XX_IRQ_EMIOS_REQUEST_HIGH_MIN) : ((v) - MPC55XX_IRQ_EMIOS_REQUEST_LOW_MIN))
+#define MPC55XX_IRQ_EMIOS_GET_REQUEST( c) (((c) >= 16U) ? ((c) - 16U + MPC55XX_IRQ_EMIOS_REQUEST_HIGH_MIN) : ((c) + MPC55XX_IRQ_EMIOS_REQUEST_LOW_MIN))
 
 /* Checks */
-#define MPC55XX_IRQ_IS_VALID(i) ((i) >= MPC55XX_IRQ_MIN && (i) <= MPC55XX_IRQ_MAX)
-#define MPC55XX_IRQ_IS_SOFTWARE(i) ((i) >= MPC55XX_IRQ_SOFTWARE_MIN && (i) <= MPC55XX_IRQ_SOFTWARE_MAX)
+#define MPC55XX_IRQ_IS_VALID(v) ((v) >= MPC55XX_IRQ_MIN && (v) <= MPC55XX_IRQ_MAX)
+#define MPC55XX_IRQ_IS_SOFTWARE(v) ((v) >= MPC55XX_IRQ_SOFTWARE_MIN && (v) <= MPC55XX_IRQ_SOFTWARE_MAX)
 
 /*
@@ -62,27 +79,27 @@
  */
 
-#define MPC55XX_INTC_INVALID_PRIORITY -1
-#define MPC55XX_INTC_DISABLED_PRIORITY 0
-#define MPC55XX_INTC_MIN_PRIORITY 1
-#define MPC55XX_INTC_MAX_PRIORITY 15
-#define MPC55XX_INTC_DEFAULT_PRIORITY MPC55XX_INTC_MIN_PRIORITY
+#define MPC55XX_INTC_MIN_PRIORITY 1U
+#define MPC55XX_INTC_MAX_PRIORITY 15U
+#define MPC55XX_INTC_DISABLED_PRIORITY 0U
+#define MPC55XX_INTC_INVALID_PRIORITY (MPC55XX_INTC_MAX_PRIORITY + 1)
+#define MPC55XX_INTC_DEFAULT_PRIORITY (MPC55XX_INTC_MIN_PRIORITY + 1)
 #define MPC55XX_INTC_IS_VALID_PRIORITY(p) ((p) >= MPC55XX_INTC_DISABLED_PRIORITY && (p) <= MPC55XX_INTC_MAX_PRIORITY)
 
 rtems_status_code mpc55xx_interrupt_handler_install(
 	rtems_vector_number vector,
-	int priority,
 	const char *info,
 	rtems_option options,
+	unsigned priority,
 	rtems_interrupt_handler handler,
 	void *arg
 );
 
-rtems_status_code mpc55xx_intc_get_priority( int i, int *p);
+rtems_status_code mpc55xx_intc_get_priority( rtems_vector_number vector, unsigned *priority);
 
-rtems_status_code mpc55xx_intc_set_priority( int i, int p);
+rtems_status_code mpc55xx_intc_set_priority( rtems_vector_number vector, unsigned priority);
 
-rtems_status_code mpc55xx_intc_raise_software_irq( int i);
+rtems_status_code mpc55xx_intc_raise_software_irq( rtems_vector_number vector);
 
-rtems_status_code mpc55xx_intc_clear_software_irq( int i);
+rtems_status_code mpc55xx_intc_clear_software_irq( rtems_vector_number vector);
 
 #ifdef __cplusplus
Index: c/src/lib/libcpu/powerpc/mpc55xx/include/regs.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/include/regs.h	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/include/regs.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -667,5 +667,5 @@
         } SRCR;
 
-        union {                 /* External Interrupt Status Register */
+        union SIU_EISR_tag {    /* External Interrupt Status Register */
             uint32_t R;
             struct {
@@ -690,5 +690,5 @@
         } EISR;
 
-        union {                 /* DMA/Interrupt Request Enable Register */
+        union SIU_DIRER_tag {   /* DMA/Interrupt Request Enable Register */
             uint32_t R;
             struct {
@@ -713,5 +713,5 @@
         } DIRER;
 
-        union {                 /* DMA/Interrupt Select Register */
+        union SIU_DIRSR_tag {   /* DMA/Interrupt Select Register */
             uint32_t R;
             struct {
@@ -724,5 +724,5 @@
         } DIRSR;
 
-        union {                 /* Overrun Status Register */
+        union SIU_OSR_tag {     /* Overrun Status Register */
             uint32_t R;
             struct {
@@ -747,5 +747,5 @@
         } OSR;
 
-        union {                 /* Overrun Request Enable Register */
+        union SIU_ORER_tag {    /* Overrun Request Enable Register */
             uint32_t R;
             struct {
@@ -770,5 +770,5 @@
         } ORER;
 
-        union {                 /* External IRQ Rising-Edge Event Enable Register */
+        union SIU_IREER_tag {   /* External IRQ Rising-Edge Event Enable Register */
             uint32_t R;
             struct {
@@ -793,5 +793,5 @@
         } IREER;
 
-        union {                 /* External IRQ Falling-Edge Event Enable Register */
+        union SIU_IFEER_tag {   /* External IRQ Falling-Edge Event Enable Register */
             uint32_t R;
             struct {
@@ -816,5 +816,5 @@
         } IFEER;
 
-        union {                 /* External IRQ Digital Filter Register */
+        union SIU_IDFR_tag {    /* External IRQ Digital Filter Register */
             uint32_t R;
             struct {
@@ -964,5 +964,5 @@
 /****************************************************************************/
     struct EMIOS_tag {
-        union {
+        union EMIOS_MCR_tag {
             uint32_t R;
             struct {
@@ -980,5 +980,5 @@
         } MCR;                  /* Module Configuration Register */
 
-        union {
+        union EMIOS_GFR_tag {
             uint32_t R;
             struct {
@@ -1011,5 +1011,5 @@
         } GFR;                  /* Global FLAG Register */
 
-        union {
+        union EMIOS_OUDR_tag {
             uint32_t R;
             struct {
@@ -1044,5 +1044,5 @@
         uint32_t emios_reserved[5];
 
-        struct {
+        struct EMIOS_CH_tag {
             union {
                 uint32_t R;    /* Channel A Data Register */
@@ -1057,5 +1057,5 @@
             } CCNTR;
 
-            union {
+            union EMIOS_CCR_tag {
                 uint32_t R;
                 struct {
@@ -1081,5 +1081,5 @@
             } CCR;              /* Channel Control Register */
 
-            union {
+            union EMIOS_CSR_tag {
                 uint32_t R;
                 struct {
@@ -2166,5 +2166,5 @@
         union {
             uint16_t R;
-        } SWTCR;                //Software Watchdog Timer Control
+        } SWTCR;                /* Software Watchdog Timer Control */
 
         uint8_t ecsm_reserved3[3];
@@ -2172,5 +2172,5 @@
         union {
             uint8_t R;
-        } SWTSR;                //SWT Service Register
+        } SWTSR;                /* SWT Service Register */
 
         uint8_t ecsm_reserved4[3];
@@ -2178,5 +2178,5 @@
         union {
             uint8_t R;
-        } SWTIR;                //SWT Interrupt Register
+        } SWTIR;                /* SWT Interrupt Register */
 
         uint32_t ecsm_reserved5a[1];
@@ -2211,5 +2211,5 @@
                 uint8_t EFNCR:1;
             } B;
-        } ECR;                  //ECC Configuration Register
+        } ECR;                  /* ECC Configuration Register */
 
         uint8_t mcm_reserved8[3];
@@ -2222,5 +2222,5 @@
                 uint8_t FNCE:1;
             } B;
-        } ESR;                  //ECC Status Register
+        } ESR;                  /* ECC Status Register */
 
         uint16_t ecsm_reserved9;
@@ -2235,5 +2235,5 @@
                 uint16_t ERRBIT:7;
             } B;
-        } EEGR;                 //ECC Error Generation Register
+        } EEGR;                 /* ECC Error Generation Register */
 
         uint32_t ecsm_reserved10;
@@ -2244,5 +2244,5 @@
                 uint32_t FEAR:32;
             } B;
-        } FEAR;                 //Flash ECC Address Register
+        } FEAR;                 /* Flash ECC Address Register */
 
         uint16_t ecsm_reserved11;
@@ -2254,5 +2254,5 @@
                 uint8_t FEMR:4;
             } B;
-        } FEMR;                 //Flash ECC Master Register
+        } FEMR;                 /* Flash ECC Master Register */
 
         union {
@@ -2266,5 +2266,5 @@
                 uint8_t PROT3:1;
             } B;
-        } FEAT;                 //Flash ECC Attributes Register
+        } FEAT;                 /* Flash ECC Attributes Register */
 
         union {
@@ -2273,5 +2273,5 @@
                 uint32_t FEDH:32;
             } B;
-        } FEDRH;                //Flash ECC Data High Register
+        } FEDRH;                /* Flash ECC Data High Register */
 
         union {
@@ -2280,5 +2280,5 @@
                 uint32_t FEDL:32;
             } B;
-        } FEDRL;                //Flash ECC Data Low Register
+        } FEDRL;                /* Flash ECC Data Low Register */
 
         union {
@@ -2287,5 +2287,5 @@
                 uint32_t REAR:32;
             } B;
-        } REAR;                 //RAM ECC Address
+        } REAR;                 /* RAM ECC Address */
 
         uint8_t ecsm_reserved12[2];
@@ -2297,5 +2297,5 @@
                 uint8_t REMR:4;
             } B;
-        } REMR;                 //RAM ECC Master
+        } REMR;                 /* RAM ECC Master */
 
         union {
@@ -2309,5 +2309,5 @@
                 uint8_t PROT3:1;
             } B;
-        } REAT;                 // RAM ECC Attributes Register
+        } REAT;                 /*  RAM ECC Attributes Register */
 
         union {
@@ -2316,5 +2316,5 @@
                 uint32_t REDH:32;
             } B;
-        } REDRH;                //RAM ECC Data High Register
+        } REDRH;                /* RAM ECC Data High Register */
 
         union {
@@ -2323,5 +2323,5 @@
                 uint32_t REDL:32;
             } B;
-        } REDRL;                //RAMECC Data Low Register
+        } REDRL;                /* RAMECC Data Low Register */
 
     };
@@ -2729,41 +2729,88 @@
             uint32_t SADDR;    /* source address */
 
-            uint16_t SMOD:5;   /* source address modulo */
-            uint16_t SSIZE:3;  /* source transfer size */
-            uint16_t DMOD:5;   /* destination address modulo */
-            uint16_t DSIZE:3;  /* destination transfer size */
-            int16_t SOFF;      /* signed source address offset */
+            /* Source and destination fields */
+            union tcd_SDF_tag {
+                uint32_t R;
+                struct {
+                    uint16_t SMOD:5;   /* source address modulo */
+                    uint16_t SSIZE:3;  /* source transfer size */
+                    uint16_t DMOD:5;   /* destination address modulo */
+                    uint16_t DSIZE:3;  /* destination transfer size */
+                    int16_t SOFF;      /* signed source address offset */
+                } B;
+            } SDF;
 
             uint32_t NBYTES;   /* inner (ÂminorÂ) byte count */
 
             int32_t SLAST;     /* last destination address adjustment, or
-
                                    scatter/gather address (if e_sg = 1) */
+
             uint32_t DADDR;    /* destination address */
 
-            uint16_t CITERE_LINK:1;
-            uint16_t CITER:15;
-
-            int16_t DOFF;      /* signed destination address offset */
+            /* CITER and destination fields */
+            union tcd_CDF_tag {
+                uint32_t R;
+                struct {
+                    uint16_t CITERE_LINK:1;
+                    uint16_t CITER:15;
+                    int16_t DOFF;      /* signed destination address offset */
+                } B;
+                struct {
+		    uint16_t CITERE_LINK:1;
+		    uint16_t CITERLINKCH:6;
+		    uint16_t CITER:9;
+                    int16_t DOFF;
+                } B_ALT;
+            } CDF;
 
             int32_t DLAST_SGA;
 
-            uint16_t BITERE_LINK:1;    /* beginning ("major") iteration count */
-            uint16_t BITER:15;
-
-            uint16_t BWC:2;    /* bandwidth control */
-            uint16_t MAJORLINKCH:6;    /* enable channel-to-channel link */
-            uint16_t DONE:1;   /* channel done */
-            uint16_t ACTIVE:1; /* channel active */
-            uint16_t MAJORE_LINK:1;    /* enable channel-to-channel link */
-            uint16_t E_SG:1;   /* enable scatter/gather descriptor */
-            uint16_t D_REQ:1;  /* disable ipd_req when done */
-            uint16_t INT_HALF:1;       /* interrupt on citer = (biter >> 1) */
-            uint16_t INT_MAJ:1;        /* interrupt on major loop completion */
-            uint16_t START:1;  /* explicit channel start */
+            /* BITER and misc fields */
+            union tcd_BMF_tag {
+                uint32_t R;
+                struct {
+                    uint32_t BITERE_LINK:1;    /* beginning ("major") iteration count */
+                    uint32_t BITER:15;
+                    uint32_t BWC:2;    /* bandwidth control */
+                    uint32_t MAJORLINKCH:6;    /* enable channel-to-channel link */
+                    uint32_t DONE:1;   /* channel done */
+                    uint32_t ACTIVE:1; /* channel active */
+                    uint32_t MAJORE_LINK:1;    /* enable channel-to-channel link */
+                    uint32_t E_SG:1;   /* enable scatter/gather descriptor */
+                    uint32_t D_REQ:1;  /* disable ipd_req when done */
+                    uint32_t INT_HALF:1;       /* interrupt on citer = (biter >> 1) */
+                    uint32_t INT_MAJ:1;        /* interrupt on major loop completion */
+                    uint32_t START:1;  /* explicit channel start */
+                } B;
+                struct {
+                    uint32_t BITERE_LINK:1;
+                    uint32_t BITERLINKCH:6;
+                    uint32_t BITER:9;
+                    uint32_t BWC:2;
+                    uint32_t MAJORLINKCH:6;
+                    uint32_t DONE:1;
+                    uint32_t ACTIVE:1;
+                    uint32_t MAJORE_LINK:1;
+                    uint32_t E_SG:1;
+                    uint32_t D_REQ:1;
+                    uint32_t INT_HALF:1;
+                    uint32_t INT_MAJ:1;
+                    uint32_t START:1;
+                } B_ALT;
+            } BMF;
         } TCD[64];              /* transfer_control_descriptor */
-
     };
 
+    static const struct tcd_t EDMA_TCD_DEFAULT = {
+        .SADDR = 0,
+        .SDF = { .R = 0 },
+        .NBYTES = 0,
+        .SLAST = 0,
+        .DADDR = 0,
+        .CDF = { .R = 0 },
+        .DLAST_SGA = 0,
+        .BMF = { .R = 0 } 
+    };
+
 #define EDMA_TCD_BITER_MASK 0x7fff
 
@@ -2776,48 +2823,6 @@
 #define EDMA_TCD_LINK_AND_BITER( link, biter) (((link) << 9) + ((biter) & EDMA_TCD_BITER_LINKED_MASK))
 
-#define EDMA_TCD_BITER_LINK( channel) (EDMA.TCD [(channel)].BITER >> 9)
-
-/* This is outside of the eDMA structure */
-/* There are 2 possible ways to use the citer bit field, this structure */
-/* uses the different format from the main structure.                   */
-    struct tcd_alt_t {
-        uint32_t SADDR;        /* source address */
-
-        uint16_t SMOD:5;       /* source address modulo */
-        uint16_t SSIZE:3;      /* source transfer size */
-        uint16_t DMOD:5;       /* destination address modulo */
-        uint16_t DSIZE:3;      /* destination transfer size */
-        int16_t SOFF;          /* signed source address offset */
-
-        uint32_t NBYTES;       /* inner (ÂminorÂ) byte count */
-
-        int32_t SLAST;         /* last destination address adjustment, or
-
-                                   scatter/gather address (if e_sg = 1) */
-        uint32_t DADDR;        /* destination address */
-
-        uint16_t CITERE_LINK:1;
-        uint16_t CITERLINKCH:6;
-        uint16_t CITER:9;
-
-        int16_t DOFF;          /* signed destination address offset */
-
-        int32_t DLAST_SGA;
-
-        uint16_t BITERE_LINK:1;        /* beginning (ÂmajorÂ) iteration count */
-        uint16_t BITERLINKCH:6;
-        uint16_t BITER:9;
-
-        uint16_t BWC:2;        /* bandwidth control */
-        uint16_t MAJORLINKCH:6;        /* enable channel-to-channel link */
-        uint16_t DONE:1;       /* channel done */
-        uint16_t ACTIVE:1;     /* channel active */
-        uint16_t MAJORE_LINK:1;        /* enable channel-to-channel link */
-        uint16_t E_SG:1;       /* enable scatter/gather descriptor */
-        uint16_t D_REQ:1;      /* disable ipd_req when done */
-        uint16_t INT_HALF:1;   /* interrupt on citer = (biter >> 1) */
-        uint16_t INT_MAJ:1;    /* interrupt on major loop completion */
-        uint16_t START:1;      /* explicit channel start */
-    };                          /* transfer_control_descriptor */
+#define EDMA_TCD_BITER_LINK( channel) (EDMA.TCD [(channel)].BMF.B.BITER >> 9)
+
 /****************************************************************************/
 /*                          MODULE : INTC                                   */
@@ -4250,4 +4255,103 @@
     };
 
+/****************************************************************************/
+/*                          MMU                                             */
+/****************************************************************************/
+    struct MMU_tag {
+        union {
+            uint32_t R;
+            struct {
+                uint32_t : 2;
+                uint32_t TLBSEL : 2;
+                uint32_t : 7;
+                uint32_t ESEL : 5;
+                uint32_t : 11;
+                uint32_t NV : 5;
+            } B;
+        } MAS0;
+
+        union {
+            uint32_t R;
+            struct {
+                uint32_t VALID : 1;
+                uint32_t IPROT : 1;
+                uint32_t : 6;
+                uint32_t TID : 8;
+                uint32_t : 3;
+                uint32_t TS : 1;
+                uint32_t TSIZ : 4;
+                uint32_t : 8;
+            } B;
+        } MAS1;
+
+        union {
+            uint32_t R;
+            struct {
+                uint32_t EPN : 20;
+                uint32_t : 7;
+                uint32_t W : 1;
+                uint32_t I : 1;
+                uint32_t M : 1;
+                uint32_t G : 1;
+                uint32_t E : 1;
+            } B;
+        } MAS2;
+
+        union {
+            uint32_t R;
+            struct {
+                uint32_t RPN : 20;
+                uint32_t : 2;
+                uint32_t U0 : 1;
+                uint32_t U1 : 1;
+                uint32_t U2 : 1;
+                uint32_t U3 : 1;
+                uint32_t UX : 1;
+                uint32_t SX : 1;
+                uint32_t UW : 1;
+                uint32_t SW : 1;
+                uint32_t UR : 1;
+                uint32_t SR : 1;
+            } B;
+        } MAS3;
+
+        union {
+            uint32_t R;
+            struct {
+                uint32_t : 2;
+                uint32_t TLBSELD : 2;
+                uint32_t : 10;
+                uint32_t TIDSELD : 2;
+                uint32_t : 4;
+                uint32_t TSIZED : 4;
+                uint32_t : 3;
+                uint32_t WD : 1;
+                uint32_t ID : 1;
+                uint32_t MD : 1;
+                uint32_t GD : 1;
+                uint32_t ED : 1;
+            } B;
+        } MAS4;
+
+        union {
+            uint32_t R;
+            struct {
+                uint32_t : 8;
+                uint32_t SPID : 8;
+                uint32_t : 15;
+                uint32_t SAS : 1;
+            } B;
+        } MAS6;
+    };
+
+    static const struct MMU_tag MMU_DEFAULT = {
+        .MAS0 = { .R = 0x10000000 },
+        .MAS1 = { .R = 0 },
+        .MAS2 = { .R = 0 },
+        .MAS3 = { .R = 0 },
+        .MAS4 = { .R = 0 },
+        .MAS6 = { .R = 0 }
+    };
+
 /* Define memories */
 
@@ -4309,5 +4413,5 @@
  *
  * Copyright:
- *	Freescale Semiconductor, INC. All Rights Reserved.
+ *  Freescale Semiconductor, INC. All Rights Reserved.
  *  You are hereby granted a copyright license to use, modify, and
  *  distribute the SOFTWARE so long as this entire notice is
